﻿class BattleControl {
	var p1, p2:Object;
	var isP1Turn:Boolean = true;
	var cmd11, cmd12, cmd13, cmd14, cmd21, cmd22, cmd23, cmd24, cmd1_bg, cmd2_bg, cmd1, cmd2, subW1, subW2, p1Info, p2Info, p1Hp, p1Sp, p2Hp, p2Sp, fightBG, dmgPanel1, dmgPanel2:Object;
	var WC:Object;
	function BattleControl(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u) {
		cmd11 = a;
		cmd12 = b;
		cmd13 = c;
		cmd14 = d;
		cmd21 = e;
		cmd22 = f;
		cmd23 = g;
		cmd24 = h;
		cmd1_bg = i;
		cmd2_bg = j;
		cmd1 = k;
		cmd2 = l;
		subW1 = m;
		subW2 = n;
		p1Info = o;
		p2Info = p;
		p1Hp = q;
		p1Sp = r;
		p2Hp = s;
		p2Sp = t;
		fightBG = u;
		
		setPanel1(false);
		setPanel2(false);
		setPanel(false);
	}
	function addWorldControl(_WC) {
		WC = _WC;
	}
	function setPanel(flag) {
		trace("setting bt panel");
		fightBG._visible = flag;
		p1Hp._visible = flag;
		p1Sp._visible = flag;
		p2Hp._visible = flag;
		p2Sp._visible = flag;
		dmgPanel1._visible = flag;
		dmgPanel2._visible = flag;
		cmd1._visible = flag;
		cmd2._visible = flag;
	}
	function toggleTrun() {
		isP1Turn = !isP1Turn;
	}
	function battleCommand1(is1) {
		if (!is1) {
			if (p2.gotCmd1(p1)) {
				isP1Turn = !isP1Turn;
			}
		} else {
			if (p1.gotCmd1(p2)) {
				isP1Turn = !isP1Turn;
			}
		}
		validate();
	}
	function battleCommand2(is1) {
		if (!is1) {
			if (p2.gotCmd2(p1)) {
				isP1Turn = !isP1Turn;
			}
		} else {
			if (p1.gotCmd2(p2)) {
				isP1Turn = !isP1Turn;
			}
		}
		validate();
	}
	function battleCommand3(is1) {
		if (!is1) {
			if (p2.gotCmd3(p1)) {
				isP1Turn = !isP1Turn;
			}
		} else {
			if (p1.gotCmd3(p2)) {
				isP1Turn = !isP1Turn;
			}
		}
		validate();
	}
	function battleCommand4(is1) {
		if (!is1) {
			if (p2.gotCmd4(p1)) {
				isP1Turn = !isP1Turn;
			}
		} else {
			if (p1.gotCmd4(p2)) {
				isP1Turn = !isP1Turn;
			}
		}
		validate();
	}
	function validate() {
		if (p1.hp>p1.hpMax) {
			p1.hp = p1.hpMax;
		}
		if (p2.hp>p2.hpMax) {
			p2.hp = p2.hpMax;
		}
		p1Hp.text = "Hp:"+p1.hp+"/"+p1.hpMax;
		p2Hp.text = "Hp:"+p2.hp+"/"+p2.hpMax;
		p1Sp.text = "Sp:"+p1.sp;
		p2Sp.text = "Sp:"+p2.sp;
		if (isP1Turn && p1.sp>0) {
			setPanel1(true);
			setPanel2(false);
		} else if (p2.sp>0) {
			setPanel1(false);
			setPanel2(true);
		} else {
			setPanel1(true);
			setPanel2(false);
		}
		if ((p1.sp == 0 && p2.sp == 0) || (p1.hp<1) || (p2.hp<1)) {
			WC.invisibleAll(true);
			WC.setPanel(true);
			WC.validate();
			p1.setPosition(p1.position);
			p2.setPosition(p2.position);
			setPanel(false);
			setPanel1(false);
			setPanel2(false);
			cmd1.pass = false;
			cmd2.pass = false;
			if (p1.hp<1) {
				p1.halt = 3;
			}
			if (p2.hp<1) {
				p2.halt = 3;
			}
		}
	}
	function rollCommand1(is1) {
		if (is1) {
			p1Info.text = p1.description[0];
		} else {
			p2Info.text = p2.description[0];
		}
	}
	function rollCommand2(is1) {
		if (is1) {
			p1Info.text = p1.description[1];
		} else {
			p2Info.text = p2.description[1];
		}
	}
	function rollCommand3(is1) {
		if (is1) {
			p1Info.text = p1.description[2];
		} else {
			p2Info.text = p2.description[2];
		}
	}
	function rollCommand4(is1) {
		if (is1) {
			p1Info.text = p1.description[3];
		} else {
			p2Info.text = p2.description[3];
		}
	}
	function addPlayer(p1In:Object, p2In:Object) {
		p1 = p1In;
		p2 = p2In;
		p1.charr._visible = true;
		p1.charl._visible = false;
		p2.charr._visible = false;
		p2.charl._visible = true;
		p2.setXY(320, 250);
		p1.setXY(220, 250);
		p1.swapDepths(_root.getNextHighestDepth());
		p2.swapDepths(_root.getNextHighestDepth());
		cmd11.text = p1.commands[0];
		cmd12.text = p1.commands[1];
		cmd13.text = p1.commands[2];
		cmd14.text = p1.commands[3];
		cmd21.text = p2.commands[0];
		cmd22.text = p2.commands[1];
		cmd23.text = p2.commands[2];
		cmd24.text = p2.commands[3];
		p1Info.text = p1.description[0];
		p2Info.text = p2.description[0];
		p1.sp = Math.floor(Math.random()*5)+2;
		p2.sp = Math.floor(Math.random()*5)+2;
		if (p1.race == "priest" && p1.sp != 6) {
			p1.sp++;
		}
		if (p2.race == "priest" && p2.sp != 6) {
			p2.sp++;
		}
		validate();
	}
	function setPanel2(flag:Boolean) {
		subW2._visible = flag;
		cmd2._visible = flag;
		cmd21._visible = flag;
		cmd22._visible = flag;
		cmd23._visible = flag;
		cmd24._visible = flag;
		cmd2_bg._visible = flag;
		subW2._visible = flag;
		p2Info._visible = flag;
	}
	function setPanel1(flag:Boolean) {
		subW1._visible = flag;
		cmd1._visible = flag;
		cmd11._visible = flag;
		cmd12._visible = flag;
		cmd13._visible = flag;
		cmd14._visible = flag;
		cmd1_bg._visible = flag;
		subW1._visible = flag;
		p1Info._visible = flag;
	}
}
