﻿class Path extends MovieClip {
	var connectedComponent:Array;
	var name:String;
	var type:String;
	var newX, newY:Number;
	var manager:Object;
	var intervalID:Number;
	function Path() {
		type = "path";
		connectedComponent = new Array();
		newX = this._x;
		newY = this._y;
		
	}
	function drifToXY(x:Number, y:Number) {
		newX = this._x+x;
		newY = this._y+y;
		clearInterval(intervalID);
		intervalID = setInterval(this, "doMove", 10);
	}
	function doMove() {
		if (Math.abs(this._x-newX)<5 && Math.abs(this._y-newY)<5) {
			clearInterval(intervalID);
			this._x = newX;
			this._y = newY;
		}
		this._x += (newX-this._x)*0.1;
		this._y += (newY-this._y)*0.1;
	}
	function addManager(inManager) {
		manager = inManager;
	}
	function isConnectedTo(inLocation) {
		var i:Number;
		i = 0;
		while (i<connectedComponent.length) {
			//trace("in Path : testing "+inLocation.name+" with "+connectedComponent[i].name);
			if (connectedComponent[i++].name == inLocation.name) {
				return 1;
			}
		}
		return 0;
	}
	function reColor() {
		this.removeMovieClip();
		if (type == "undefined" || type == "path") {
			this.attachMovie("foo", "name1", this.getNextHighestDepth());
			type = "foo";
		} else {
			this.attachMovie("path", "name1", this.getNextHighestDepth());
			type = "path";
		}
	}
	function onRelease() {
		manager.moveToNewLocation(this);
		//intervalID = setInterval(this, "doMovee", 100);
	}
	function setConnected(inPath:Path, count:Number) {
		connectedComponent.push(inPath);
		if (count == 1) {
			inPath.setConnected(this, 0);
		}
	}
	function setName(inName:String) {
		name = inName;
	}
}
