﻿class Player extends MovieClip {
	var rollMenu, itemMenu, questMenu:Menuu;
	var charl, charr:MovieClip;
	var isTurn:Boolean = false;
	var isRoll:Boolean;
	var oldPos:Object;
	var position:Object;
	var newX, newY, intervalID, moveLeft, playOrder,avoid:Number;
	
	var manager:Object;
	var quest, done, isFinishMove:Boolean;
	var demon, gold, hp, hpMax, halt, att, def, sp, hunterCount, hunterInterval, knightBlockChance:Number;
	var moveText:Object;
	var itemList:Array;
	var commands:Array;
	var commandSP:Array;
	var description:Array;
	var race:String;
	var dmgPanel:Object;
	var charFace, charBG, movePanel, hpPanel, goldPanel, warp:Object;
	function Player(inrace:String, _playOrder:Number) {
		avoid=0;
		hp = 0;
		gold = 0;
		isRoll = false;
		playOrder = _playOrder;
		race = inrace;
		itemList = new Array(10);
		for (var i = 0; i<10; i++) {
			itemList[i] = 0;
		}
		commands = new Array();
		commandSP = new Array();
		description = new Array();
		commands.push("Attack");
		commandSP.push(1);
		if (race == "knight") {
			knightBlockChance = 0.7;
			hp = hpMax=90;
			att = 12;
			def = 4;
			description.push("Attack the enemy with your sword");
			commands.push("skill1");
			description.push("do a heavy strike");
			commandSP.push(2);
			commands.push("block");
			description.push("increase chance of block to 40%");
			commandSP.push(2);
		}
		if (race == "undead") {
			hp = hpMax=85;
			att = 9;
			def = 4;
			description.push("Attack your enemy ... steal life force");
			commands.push("suicide");
			description.push("explode yourself");
			commandSP.push(5);
			commands.push("bite");
			description.push("more efficient way in steal life");
			commandSP.push(2);
		}
		if (race == "hunter") {
			hp = hpMax=75;
			att = 10;
			def = 3;
			description.push("Attack the enemy with your bow");
			description.push("fire 4 shots at a time");
			description.push("piercing shot that ignore armor");
			commands.push("multiShot");
			commandSP.push(3);
			commands.push("pierce");
			commandSP.push(2);
		}
		if (race == "wizard") {
			hp = hpMax=70;
			att = 14;
			def = 2;
			description.push("Attack the enemy with your staff");
			description.push("attack with magic");
			description.push("attack with special magic");
			commands.push("magic");
			commandSP.push(2);
			commands.push("magicMax");
			commandSP.push(4);
		}
		if (race == "priest") {
			hp = hpMax=75;
			att = 10;
			def = 3;
			description.push("Attack your enemy with your fist");
			commands.push("heal 1");
			description.push("heal your self");
			commandSP.push(2);
			commands.push("heal 2");
			description.push("use super heal");
			commandSP.push(4);
		}
		if (race == "theif") {
			hp = hpMax=70;
			att = 8;
			def = 3;
			description.push("Attack your enemy with your knife");
			commands.push("escape");
			description.push("try to escape from battle");
			commandSP.push(2);
			commands.push("stab");
			description.push("backstab with your enemy");
			commandSP.push(4);
		}
		commands.push("escape");
		commandSP.push(1);
		description.push("run from battle");
		gold = 1000;
		halt = 0;
		isFinishMove = true;
		demon = 11;
		quest = false;
		done = false;
		charl = _root.attachMovie(race+"l", "charl", _root.getNextHighestDepth());
		charl.addPlayerControl(this);
		charr = _root.attachMovie(race+"r", "charr", _root.getNextHighestDepth());
		charr.addPlayerControl(this);
		charl._visible = false;
		charl._width = 30;
		charl._height = 30;
		charr._width = 30;
		charr._height = 30;
		rollMenu = _root.attachMovie("roll", "roll1", _root.getNextHighestDepth());
		rollMenu.addPlayer(this);
		itemMenu = _root.attachMovie("item", "item1", _root.getNextHighestDepth());
		itemMenu.addPlayer(this);
		//questMenu = _root.attachMovie("quest", "quest1", _root.getNextHighestDepth());
		//questMenu.addPlayer(this);
		//charBG = _root.attachMovie("charBG", "charBG1", _root.getNextHighestDepth());
		charBG._y = 309;
		charBG._x = 46+(playOrder*66);
		charFace = _root.attachMovie(race+"face", "face1", _root.getNextHighestDepth());
		charFace._y = 323;
		charFace._x = 120+((playOrder-1)*66);
		rollMenu._visible = false;
		itemMenu._visible = false;
		questMenu._visible = false;
		moveLeft = 0;
	}
	function addPanel(_movePanel, _hpPanel, _goldPanel) {
		movePanel = _movePanel;
		addMoveText(movePanel);
		movePanel._y = 319;
		movePanel._x = 150+((playOrder-1)*66);
		movePanel.swapDepths(30);
		hpPanel = _hpPanel;
		hpPanel._y = 349;
		hpPanel._x = 143+((playOrder-1)*66);
		hpPanel.swapDepths(31);
		goldPanel = _goldPanel;
		goldPanel.swapDepths(32);
		goldPanel._y = 370;
		goldPanel._x = 141+((playOrder-1)*66);
		validate();
	}
	function addDamagePanel(dmg) {
		dmgPanel = dmg;
	}
	function addWarp(_warp) {
		warp = _warp;
	}
	function getCommand(pos:Number) {
		return commands[pos];
	}
	function addMoveText(t) {
		moveText = t;
		moveText.text = moveLeft;
	}
	function addManager(inManager) {
		manager = inManager;
		rollMenu.addManager(inManager);
	}
	function setPosition(inLocation) {
		position = inLocation;
		charr._x = charl._x=inLocation._x;
		charr._y = charl._y=inLocation._y-20;
	}
	function setXY(x:Number, y:Number) {
		charr._x = charl._x=x;
		charr._y = charl._y=y;
	}
	function setMove(inMove) {
		isRoll = true;
		moveLeft = inMove;
		moveText.text = inMove;
		avoid--;
		if (avoid<0) {
			avoid = 0;
		}
	}
	function getMove() {
		return moveLeft;
	}
	function setEvent(cmd:String) {
		var t:String;
		if (cmd.slice(0, 5) == "Event") {
			t = cmd.slice(5, cmd.indexOf(":"));
			if (t == "เงิน...... หายยยย!!!") {
				gold -= 50;
			}
			if (t == "เด็กน้อยผู้น่าสงสาร") {
				gold -= 100;
			}
			if (t == "ไม่ไหวแล้วววว") {
				gold -= 150;
			}
			if (t == "พบเพื่อนเก่า") {
				gold -= 200;
			}
			if (t == "ใช้หนี้!!!!") {
				gold -= 500;
			}
			if (t == "พบเงินตก") {
				gold += 25;
			}
			if (t == "ช่วยนก....น้อย") {
				gold += 75;
			}
			if (t == "ช่วย master ทำงาน") {
				gold += 200;
			}
			if (t == "ได้เงินเดือน") {
				gold += 500;
			}
			if (t == "... ความโลภเป็นเหตุ") {
				hp -= 20;
			}
			if (t == "...อาหารเป็นพิษ") {
				hp -= 10;
			}
			if (t == "อ้าก... ตะปูแทงเท้า") {
				hp -= 5;
			}
			if (t == "หกล้ม") {
				hp -= 2;
			}
			if (t == "ช่วยลูกแมว") {
				hp += 1;
			}
			if (t == "ฝนตกพรำๆ") {
				hp += 5;
			}
			if (t == "ชาวบ้านใจดี") {
				hp += 10;
			}
			if (t == "กินฟรี") {
				hp = hpMax;
			}
			if (t == "เอ...ทางไหนหวา") {
				halt = 2;
			}
			if (t == "หนักจังเล้ยยยยย") {
				halt = 3;
			}
			trace(hp+" "+halt+" "+gold);
		}
		t = cmd;
		trace("item before slice :"+t.slice(4, t.length));
		if (t.slice(0, 4) == "Item") {
			trace("get item "+t.slice(4, t.length));
			if (t.slice(4, t.length) == "Hero trial") {
				itemList[0]++;
			}
			if (t.slice(4, t.length) == "Hero trial half") {
				itemList[1]++;
			}
			if (t.slice(4, t.length) == "Armagedon") {
				itemList[2]++;
			}
			if (t.slice(4, t.length) == "Judgement day") {
				itemList[3]++;
			}
			if (t.slice(4, t.length) == "tent") {
				itemList[4]++;
			}
			if (t.slice(4, t.length) == "lesser healing potion") {
				itemList[5]++;
			}
			if (t.slice(4, t.length) == "less healing potion") {
				itemList[6]++;
			}
			if (t.slice(4, t.length) == "healing potion") {
				itemList[7]++;
			}
			if (t.slice(4, t.length) == "greater healing potion") {
				itemList[8]++;
			}
			if (t.slice(4, t.length) == "phenix down") {
				itemList[9]++;
			}
		}
		trace(itemList);
		validate();
	}
	function validate() {
		moveText.text = moveLeft;
		hpPanel.text = hp;
		goldPanel.text = gold;
	}
	function moveToNewLocation(inLocation) {
		trace("moving to new location ");
		if (position.isConnectedTo(inLocation) == 1 && moveLeft>0) {
			//&& oldPos.name != inLocation.name) {
			oldPos = position;
			moveLeft--;
			validate();
			//			this._visible = false;
			if (inLocation._x<position._x) {
				charl._visible = true;
				charr._visible = false;
			}
			if (inLocation._x>=position._x) {
				charr._visible = true;
				charl._visible = false;
			}
			position = inLocation;
			newX = position._x;
			newY = position._y;
			clearInterval(intervalID);
			intervalID = setInterval(this, "doMove", 10);
			var t:String;
/*			t = new String(position.name);
			if (t.indexOf("warp") != -1) {
				warp._visible = true;
				warp.gotoAndPlay(1);
			}*/
			rollMenu._visible = false;
			itemMenu._visible = false;
			questMenu._visible = false;
		}
	}
	function drifToXY(x:Number, y:Number) {
		newX = charr._x+x;
		newY = charr._y+y;
		clearInterval(intervalID);
		intervalID = setInterval(this, "doMove", 10);
	}
	function showMenu() {
		if (rollMenu._visible == false || rollMenu._visible == undefined) {
			rollMenu._visible = true;
			itemMenu._visible = true;
			questMenu._visible = true;
			rollMenu._x = charr._x-25;
			questMenu._x = charr._x+25;
			itemMenu._x = charr._x;
			rollMenu._y = questMenu._y=charr._y;
			itemMenu._y = charr._y-30;
		} else {
			rollMenu._visible = false;
			itemMenu._visible = false;
			questMenu._visible = false;
		}
	}
	function doMove() {
		if (Math.abs(charr._x-position.newX)<4 && Math.abs(charr._y-position.newY+20)<4) {
			clearInterval(intervalID);
			isFinishMove = true;
			charr._x = position.newX;
			charl._x = position.newX;
			charr._y = position.newY-20;
			charl._y = position.newY-20;
		}
		charr._x += (position.newX-charr._x)*0.1;
		charr._y += (position.newY-20-charr._y)*0.1;
		charl._x += (position.newX-charl._x)*0.1;
		charl._y += (position.newY-20-charr._y)*0.1;
		rollMenu._x = charr._x-25;
		questMenu._x = charr._x+25;
		itemMenu._x = charr._x;
		rollMenu._y = questMenu._y=charr._y;
		itemMenu._y = charr._y-30;
	}
	function gotHit(val:Number) {
		if (val>=def) {
			if (race == "hunter" && (Math.random()>0.79)) {
				return 0;
			}
			if (race == "knight" && (Math.random()>knightBlockChance)) {
				hp -= Math.floor((val-def)*0.7);
				return Math.floor((val-def)*0.7);
			}
			hp -= (val-def);
			return (val-def);
		}
		return 0;
	}
	function doHit() {
		return att;
	}
	function hunterShot(other:Object) {
		var temp:Number;
		if (--hunterCount>=0) {
			temp = other.gotHit(doHit());
			other.showDamage(-temp);
		} else {
			clearInterval(hunterInterval);
		}
	}
	function showDamage(point) {
		clearInterval(intervalID);
		dmgPanel.text = Math.abs(point);
		dmgPanel.textColor = 0x00FF00;
		if (point<=0) {
			dmgPanel.textColor = 0xFF0000;
		}
		if (point == 0) {
			dmgPanel.text = "miss";
		}
		dmgPanel._visible = true;
		dmgPanel._x = charr._x;
		dmgPanel._y = charr._y-30;
		intervalID = setInterval(this, "doShowDamage", 10);
	}
	function doShowDamage() {
		if ((charr._y-dmgPanel._y)<80) {
			dmgPanel._y = dmgPanel._y-3;
			dmgPanel._alpha = dmgPanel._alpha*0.4;
		} else {
			dmgPanel._visible = false;
			clearInterval(intervalID);
		}
	}
	function gotCmd1(other:Object) {
		var temp:Number;
		if (sp>=commandSP[0]) {
			sp -= commandSP[0];
			temp = other.gotHit(doHit());
			other.showDamage(-temp);
			if (race == "undead") {
				if (temp>3) {
					temp = 3;
				}
				if (race == "theif") {
					if (Math.random()>0.75) {
						temp = Math.floor((other.gold/10));
						gold += temp;
						other.gold -= temp;
					}
				}
				hp += temp;
				showDamage(temp);
			}
			return true;
		} else {
			return false;
		}
	}
	function gotCmd2(other:Object) {
		trace("cmd2");
		var temp:Number;
		if (sp>=commandSP[1]) {
			sp -= commandSP[1];
			if (race == "hunter") {
				hunterCount = 4;
				hunterInterval = setInterval(this, "hunterShot", 200, other);
			}
			if (race == "knight") {
				temp = other.gotHit(18);
				other.showDamage(-temp);
			}
			if (race == "undead") {
				temp = other.gotHit(other.def+Math.floor((other.hp*0.6)));
				other.showDamage(-temp);
				showDamage(Math.ceil((hp*0.6))-20-hp);
				hp = Math.ceil((hp*0.6))-20;
			}
			if (race == "wizard") {
				temp = other.gotHit(26);
				other.showDamage(-temp);
			}
			if (race == "priest") {
				hp += 15;
				other.showDamage(15);
			}
			if (race == "theif") {
				if (Math.random()>0.15) {
					other.sp = 0;
					sp = 0;
				}
			}
			return true;
		} else {
			return false;
		}
	}
	function gotCmd3(other:Object) {
		var temp:Number;
		if (sp>=commandSP[2]) {
			sp -= commandSP[2];
			if (race == "hunter") {
				other.gotHit(other.def+10);
				other.showDamage(-10);
			}
			if (race == "knight") {
				knightBlockChance = 0.6;
			}
			if (race == "undead") {
				other.showDamage(-8);
				other.hp -= 8;
				hp += 8;
				showDamage(8);
			}
			if (race == "wizard") {
				temp = other.gotHit(40);
				other.showDamage(-temp);
			}
			if (race == "priest") {
				hp += 28;
				other.showDamage(28);
			}
			if (race == "theif") {
				temp = other.getHit(15);
				other.showDamage(-temp);
			}
			return true;
		} else {
			return false;
		}
	}
	function gotCmd4(other:Object) {
		trace("cmd4");
		var temp:Number;
		if (sp>=commandSP[3]) {
			sp -= commandSP[3];
			if (Math.random()>0.75) {
				other.sp = 0;
				sp = 0;
			}
			return true;
		} else {
			return false;
		}
	}
	function useItem(cmd:Number) {
		itemList[cmd]--;
		if (cmd == 0) {
			avoid = 4;
		}
		if (cmd == 1) {
			avoid = 2;
		}
		if (cmd == 2) {
			for (var i = 0; i<manager.maxPlayer; i++) {
				manager.player[i].hp -= 10;
			}
			manager.validate();
		}
		if (cmd == 3) {
			for (var i = 0; i<manager.maxPlayer; i++) {
				manager.player[i].hp -= 15;
			}
			manager.validate();
		}
		if (cmd == 4) {
			hp = hpMax;
		}
		if (cmd == 5) {
			hp += 5;
			manager.validate();
		}
		if (cmd == 6) {
			hp += 10;
			manager.validate();
		}
		if (cmd == 7) {
			hp += 15;
			manager.validate();
		}
		if (cmd == 8) {
			hp += 20;
			manager.validate();
		}
	}
}
