﻿class World {
	var player:Array;
	var paths:Array;
	var stopFrame:Number;
	var Turn, maxPlayer:Number;
	var isFight:Boolean;
	var BG:Object;
	var msg, cbg, foo, top, BT:Object;
	var dice:Object;
	var eventDice:Object;
	var quests:Array;
	var qCount:Array;
	var intervalID:Number;
	var currentQuest:Object;
	function World(_maxPlayer:Number) {
		maxPlayer = _maxPlayer;
		Turn = 0;
		player = new Array();
		paths = new Array();
		quests = new Array();
		qCount = new Array();
		for (var i = 0; i<_maxPlayer; i++) {
			qCount.push(0);
		}
		dice = _root.attachMovie("Mc_abc", "dice1", _root.getNextHighestDepth());
		eventDice = _root.attachMovie("Mc_eventDice", "dice2", _root.getNextHighestDepth());
		eventDice._x = 350;
		eventDice._y = 80;
		dice._x = 50;
		dice._y = 80;
		quests[0] = new Array();
		quests[0].push(new Quest("อารักขาสมบัติ"));
		quests[0].push(new Quest("ภารกิจวิษณุ"));
		quests[1] = new Array();
		quests[1].push(new Quest("วันเกิดของ cheiftain"));
		quests[1].push(new Quest("ดาบมรกตของอีฟ"));
		quests[2] = new Array();
		quests[2].push(new Quest("อารักขาสมบัติ"));
		quests[2].push(new Quest("ภารกิจลัพธ์"));
		quests[3] = new Array();
		quests[3].push(new Quest("ลูกแก้วพรายมังกร"));
		quests[3].push(new Quest("บูมบาลาก้า พระราชินีป่วย"));
		quests[4] = new Array();
		quests[4].push(new Quest("วันเกิดของ cheiftain"));
		quests[4].push(new Quest("ภารกิจลัพธ์"));
	}
	function addBattleControl(_BT) {
		BT = _BT;
	}
	function attachText(txt, txt2) {
		dice.attachText(txt);
		eventDice.attachText(txt2);
	}
	function attachChatBG(cbgIn:Object) {
		cbg = cbgIn;
	}
	function attachTop(t:Object) {
		top = t;
		top.text = "Mario's turn";
	}
	function attachPanel(a) {
		foo = a;
	}
	function getMove(race) {
		return dice.run(race);
	}
	function getEvent() {
		isFight = false;
		var t:String;
		t = eventDice.run();
		if (t.slice(0, 4) == "Item") {
			top.text = "you got an item , "+(t.slice(4, t.length));
		}
		if (t.slice(0, 5) == "Event") {
			top.text = "something happen , "+t.slice(5, t.indexOf(":"));
			msg._visible = true;
			cbg._visible = true;
			msg.text = t.slice(t.indexOf(":")+1, t.length);
		}
		if (t == "Fight" ) {
			isFight = true;
		}
		setPanel(!msg._visible);
		return t;
	}
	function addBackGround(inBG) {
		BG = inBG;
	}
	function addMsg(inMsg) {
		msg = inMsg;
	}
	function addPath(inLocation) {
		paths.push(inLocation);
		inLocation.addManager(this);
	}
	function addPlayer(_player) {
		player.push(_player);
		player[player.length-1].addManager(this);
		player[0].isTurn = true;
		player[0].isRoll = false;
	}
	function isGonnaFight() {
		var flag:Boolean = false;
		var toFight:Object;
		for (var i = 0; i<maxPlayer; i++) {
			if ((player[Turn].position.name == player[i].position.name) && (i != Turn) && (player[i].avoid == 0)) {
				flag = true;
				toFight = player[i];
			}
		}
		if (flag) {
			return toFight;
		}
		return null;
	}
	function doFight(toFight) {
		invisibleAll(false);
		setPanel(false);
		BT.setPanel(true);
		BT.cmd1.pass = true;
		BT.cmd2.pass = true;
		player[Turn].addDamagePanel(BT.dmgPanel1);
		toFight.addDamagePanel(BT.dmgPanel2);
		clearInterval(player[Turn].IntervalID);
		BT.addPlayer(player[Turn], toFight);
	}
	function moveToNewLocation(inPath) {
		player[Turn].moveToNewLocation(inPath);
		var temp:Object;
		temp = isGonnaFight();
		if (temp != null&&player[Turn].moveLeft>0) {
			doFight(temp);
		} else {
			msg._visible = false;
			cbg._visible = false;
			if (quests[Turn][qCount[Turn]].isTrig(player[Turn].position.name) == 1) {
				msg._visible = true;
				cbg._visible = true;
				msg.text = quests[Turn][qCount[Turn]].getSpeech();
				if (quests[Turn][qCount[Turn]].getMiniGame() != " ") {
					stopFrame = 53;
					if (quests[Turn][qCount[Turn]].getMiniGame() == "quest_openCave") {
						stopFrame = 102;
					}
					if (quests[Turn][qCount[Turn]].getMiniGame() == "quest_aleebabaa") {
						stopFrame = 70;
					}
					currentQuest.unloadMovie();
					currentQuest._visible = false;
					clearInterval(intervalID);
					currentQuest = _root.attachMovie(quests[Turn][qCount[Turn]].getMiniGame(), "tempQuest", _root.getNextHighestDepth());
					intervalID = setInterval(this, "waitQuest", 100);
				} else {
					quests[Turn][qCount[Turn]].nextStep();
				}
				if (quests[Turn][qCount[Turn]].done) {
					qCount[Turn]++;
				}
			}
			setPanel((!msg._visible) && (temp == null));
			if (player[Turn].getMove() == 0 && (player[Turn].isRoll)) {
				trace("old turn :"+Turn);
				Turn = (++Turn)%maxPlayer;
				if (player[Turn].halt != 0 && player[Turn].itemList[9]>0) {
					player[Turn].halt = 0;
					player[Turn].itemList[9]--;
					player[Turn].hp = player[Turn].hpMax;
				}
				while (player[Turn].halt != 0) {
					player[Turn].halt--;
					if (player[Turn].halt != 0) {
						player[Turn].hp = player[Turn].hpMax;
					}
					Turn = (++Turn)%maxPlayer;
					trace("old turn :"+Turn);
				}
				for (var i = 0; i<maxPlayer; i++) {
					player[Turn].isTurn = false;
					player[Turn].isRoll = true;
				}
				player[Turn].isTurn = true;
				player[Turn].isRoll = false;
				moveScreen(player[Turn].charr._x, player[Turn].charr._y);
				player[Turn].showMenu();
				top.text = player[Turn].race+"'s turn";
			}
		}
	}
	function invisibleAll(flag) {
		for (var i = 0; i<maxPlayer; i++) {
			if (!flag) {
				player[i].charr._visible = false;
				player[i].charl._visible = false;
			} else {
				player[i].charr._visible = false;
				player[i].charl._visible = true;
			}
		}
	}
	function validate() {
		for (var i = 0; i<maxPlayer; i++) {
			if (player[i].hp>player[i].hpMax) {
				player[i].hp = player[i].hpMax;
			}
			if (player[i].hp<1) {
				player[i].halt = 3;
			}
			player[i].moveText.text = player[i].moveLeft;
			player[i].hpPanel.text = player[i].hp+"/"+player[i].hpMax;
			player[i].goldPanel.text = player[i].gold;
		}
	}
	function waitQuest() {
		trace(currentQuest._currentframe+" "+currentQuest.pass);
		if (currentQuest._currentframe>=stopFrame && currentQuest.pass == true) {
			quests[Turn][qCount[Turn]].nextStep();
		}
		if (currentQuest._currentframe>=stopFrame) {
			currentQuest.unloadMovie();
			currentQuest._visible = false;
			clearInterval(intervalID);
		}
	}
	function setPanel(flag:Boolean) {
		foo._visible = flag;
		for (var i = 0; i<maxPlayer; i++) {
			player[i].charFace._visible = flag;
			player[i].charB._visible = flag;
			player[i].movePanel._visible = flag;
			player[i].hpPanel._visible = flag;
			player[i].goldPanel._visible = flag;
		}
	}
	function moveScreen(xx:Number, yy:Number) {
		//trace("moving world"+(275-char._x)+" "+(200-char._y));
		var diffX, diffY:Number;
		var i:Number;
		diffX = 275-xx;
		diffY = 200-yy;
		i = 0;
		while (i<paths.length) {
			paths[i++].drifToXY(diffX, diffY);
		}
		for (var i = 0; i<maxPlayer; i++) {
			player[i].drifToXY(diffX, diffY);
		}
		BG.drifToXY(diffX, diffY);
	}
}
